PACKAGE arq_pack IS
	TYPE tri_estado IS ('0','1','Z');
	TYPE VECTOR_BUS IS ARRAY (3 DOWNTO 0) OF tri_estado;

	TYPE array_vector_bus IS ARRAY (INTEGER RANGE <>) OF vector_bus;

	FUNCTION resolucion(entrada:array_vector_bus)RETURN vector_bus;
	SUBTYPE bus_resuelto IS resolucion vector_bus;

	PROCEDURE logico_entero(VARIABLE vector:IN BIT_VECTOR;
				VARIABLE entero:OUT INTEGER);

	PROCEDURE entero_logico(VARIABLE entero:IN INTEGER;
				VARIABLE vector:OUT BIT_VECTOR);
END arq_pack;

PACKAGE BODY arq_pack IS
	FUNCTION resolucion(entrada:array_vector_bus)RETURN vector_bus IS
	VARIABLE dato:VECTOR_BUS:=('Z','Z','Z','Z');
	BEGIN
		FOR i IN entrada'RANGE LOOP
			FOR k IN 0 TO 3 LOOP
				IF entrada(i)(k)='1'THEN dato(k):='1';
				ELSIF (entrada(i)(k)='0'
				 AND dato(k)/='1')THEN dato(k):='0';
				END IF;
			END LOOP;
		END LOOP;
		RETURN dato;
		
	END resolucion;

	PROCEDURE logico_entero(VARIABLE vector:IN BIT_VECTOR;
				VARIABLE entero:OUT INTEGER)IS
	VARIABLE valor:INTEGER;
	BEGIN
	valor:=0;
		FOR i IN vector'RANGE LOOP
			IF vector(i)='1' THEN
				valor:=valor+2**i;
			END IF;
		END LOOP;
	entero:=valor;
	END logico_entero;

	PROCEDURE entero_logico(VARIABLE entero:IN INTEGER;
				VARIABLE vector:OUT BIT_VECTOR)IS
	VARIABLE valor:INTEGER;
	BEGIN
	valor:=entero;
		FOR i IN vector'REVERSE_RANGE LOOP
			vector(i):=BIT'VAL(valor REM 2);
			valor:=valor/2;
		END LOOP;
	END entero_logico;
END arq_pack;